Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes | Private Member Functions | Related Functions
openvrml::mfstring Class Reference

A string array node field value. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::mfstring:
[legend]

List of all members.

## Public Types

typedef std::vector< std::string > | value_type
| Type of value.

## Public Member Functions

| mfstring (std::vector< std::string >::size_type n=0, const std::string &value=std::string()) throw ( std::bad_alloc )
| Construct.
| mfstring (const value_type &value) throw ( std::bad_alloc )
| Construct.
| mfstring (const mfstring &mfs)
| Construct a copy.
virtual | ~mfstring () throw ()
| Destroy.
mfstring & | operator= (const mfstring &mfs) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (mfstring &mfs) throw ()
| Swap.

## Static Public Attributes

static const type_id | field_value_type_id = mfstring_id
| `field_value::type_id` for this class.

## Private Member Functions

virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual mfstring & | do_assign (const field_value &value) throw ( std::bad_cast , std::bad_alloc )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the `field_value::type_id` associated with this class.
virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfstring &lhs, const mfstring &rhs) throw()
| Compare for equality.
bool | operator!= (const mfstring &lhs, const mfstring &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfstring &a, openvrml::mfstring &b)
| Swap the values of `a` and `b`.

## Detailed Description

A string array node field value.

Model of
  Field Value

## Member Typedef Documentation

openvrml::mfstring::value_type

Type of value.

## Constructor & Destructor Documentation

openvrml::mfstring::mfstring | ( | std::vector< std::string >::size_type | n = `0`,
|  | const std::string & | value = `std::string()`
| ) |  | throw ( std::bad_alloc )`[explicit]`

Construct.

Creates an `mfstring` with `n` copies of `value`.

Parameters:

  [in] | n | the number elements in mfstring::value.
  [in] | value | used to initialize mfstring::value.

Exceptions:

  std::bad_alloc | if memory allocation fails.

Postcondition:
  `mfstring::value.size()` is `n`. Every element in mfstring::value is a copy of `value`.

openvrml::mfstring::mfstring | ( | const value_type & | value | ) | throw ( std::bad_alloc )`[inline, explicit]`

Construct.

Parameters:

  [in] | value | initial value.

Exceptions:

  std::bad_alloc | if memory allocation fails.

openvrml::mfstring::mfstring | ( | const mfstring & | mfs | ) |

Construct a copy.

Parameters:

  [in] | mfs | the instance to copy.

openvrml::mfstring::~mfstring | ( |  | ) | throw ()`[virtual]`

Destroy.

Each of the `mfstring`'s elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

openvrml::mfstring & openvrml::mfstring::operator= | ( | const mfstring & | mfs | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  [in] | mfs | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  std::bad_alloc | if memory allocation fails.

const openvrml::mfstring::value_type & openvrml::mfstring::value | ( |  | ) | const throw ()

Access.

Returns:
  the string values.

Reimplemented from openvrml::field_value.

void openvrml::mfstring::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  [in] | val | the new value.

Exceptions:

  std::bad_alloc | if memory allocation fails.

void openvrml::mfstring::swap | ( | mfstring & | mfs | ) | throw ()

Swap.

Parameters:

  [in,out] | mfs | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::mfstring::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::mfstring & openvrml::mfstring::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast , std::bad_alloc )`[private, virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  std::bad_cast | if `value` is not an mfstring object.
  std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::field_value::type_id openvrml::mfstring::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the `field_value::type_id` associated with this class.

Returns:
  `field_value::mfstring_id`.

Implements openvrml::field_value.

void openvrml::mfstring::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  [in,out] | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfstring & | lhs,
|  | const mfstring & | rhs
| ) |  | throw()`[related]`

Compare for equality.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfstring & | lhs,
|  | const mfstring & | rhs
| ) |  | throw()`[related]`

Compare for inequality.

Parameters:

  [in] | lhs | left-hand operand.
  [in] | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfstring & | a,
|  | openvrml::mfstring & | b
| ) |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  [in,out] | a |
  [in,out] | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::mfstring::field_value_type_id = mfstring_id`[static]`

`field_value::type_id` for this class.